/***************************************************************
 * Author      : Jack Zhang
 * Date        : 2014-12-19 上午9:57:19
 * Version     : 1.0
 * Copyright (c) 2013 the SEWISE inc. All rights reserved.
 ---------------------------------------------------------------
 * File        : Statistics.as
 * Description : Statistics.as
 ***************************************************************/

package utils
{
	//import com.demonsters.debugger.MonsterDebugger;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.HTTPStatusEvent;
	import flash.events.TimerEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.utils.Timer;
	
	public class Statistics
	{
		private var _skin:MovieClip;
		private var _urlLoader:URLLoader;
		private var _variables:URLVariables;
		private var _urlRequest:URLRequest;
		private var _requestData:Object;
		
		public function Statistics(data:Object, skin:MovieClip)
		{
			//MonsterDebugger.initialize(this);
			_skin = skin;
			////////////////////////////
			var playCountData = data["playCount"];
			if(playCountData){
				runPlayCount(playCountData);
			}
		}
		private function runPlayCount(data){
			var requestURL:String = data["request-url"];
			var countDelayTime = data["request-data"]["intervallen"] ? data["request-data"]["intervallen"] : 10000;
			_requestData = data["request-data"];
			_requestData["playtime"] = _skin.getPlayTime();
			
			_variables = new URLVariables();
			_variables.data = JSON.stringify(_requestData);
			_urlRequest = new URLRequest(requestURL);
			_urlRequest.method = URLRequestMethod.POST;
			_urlRequest.data = _variables
			_urlLoader = new URLLoader();
			_urlLoader.addEventListener(Event.COMPLETE, urlLoaderCompleteHandler);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR, urlLoaderErrorHandler);
			_urlLoader.addEventListener(HTTPStatusEvent.HTTP_STATUS, urlLoaderStatusHandler);
			_urlLoader.load(_urlRequest);
			
			var requestTimer:Timer = new Timer(countDelayTime);
			requestTimer.start(); 
			requestTimer.addEventListener(TimerEvent.TIMER, requestTimerHandler);
		}
		private function urlLoaderCompleteHandler(e:Event):void{
			//trace("loader Complete! " + urlLoader.data);
		}
		private function urlLoaderErrorHandler(e:Event):void{
			//trace("loader error!");
		}
		private function urlLoaderStatusHandler(e:HTTPStatusEvent):void {
			//trace("status: " + e.status);
			//MonsterDebugger.trace(this, "status: " + e.status);
		}
		private function requestTimerHandler(e:TimerEvent):void{
			//trace("timerHandler");
			//MonsterDebugger.trace(this, "timerHandler");
			
			_requestData["playtime"] = _skin.getPlayTime();
			_variables.data = JSON.stringify(_requestData);
			_urlRequest.data = _variables;
			_urlLoader.load(_urlRequest);
		}
		
	}
}