# Sewise Player参数说明

## 一、参数说明
### 1、点、直播通用参数：
### autostart
* 说明：[可选]加载视频地址等信息后是否自动开始播放
* 类型：字符串
* 取值："true"、"false"，为空表示："true"
* 对应：通用

### skin
* 说明：[可选]播放器皮肤的相对路径
* 类型：字符串
* 取值：如，"vodOrange"
* 对应：通用

### buffer
* 说明：[可选]播放器开始播放前所需下载的缓冲数据时长，单位：秒
* 类型：浮点数
* 取值：如，5
* 对应：通用

### sourceid, pid
* 说明：[可选]被播放节目的id，sourceid用于点播，pid用于直播
* 类型：字符串
* 取值：sewise点播或直播服务中节目的id，如：'5v6s3gkk'，为空表示：需要从JS调用相关方法进行视频播放
* 对应：通用

### title
* 说明：[可选]所播放节目的标题
* 类型：字符串
* 取值：如，"深圳卫视"
* 对应：通用

### server
* 说明：[可选]服务器类型
* 类型：字符串
* 取值："vod"、live"，值为vod时播放器将启用点播模式，值为live时播放器将启用直播模式。
* 对应：通用

### type
* 说明：[可选]播放视频类型
* 类型：字符串
* 取值："rtmp"、"http"、"flv"、"mp4"、"m3u8" 为空表示：默认的flv播放模式，其中rtmp、http为直播的播放模式；flv、mp4、m3u8为点播的播放模式
* 对应：通用

### draggable
* 说明：[可选]进度条是否可以拖动
* 类型：字符串
* 取值："true"、"false"，缺省默认值为："true"
* 对应：通用

### published
* 说明：[可选]是否去检查节目发布状态的开关参数
* 类型：数值
* 取值：0或1,0表示：不需要检查节目是否发布，即无论节目是否发布都尝试去播放节目的源；1表示：需要检查节目的发布状态，未发布则不请求节目源地址
* 对应：通用

### lang
* 说明：[可选]播放器显示语言
* 类型：字符串
* 取值："en_US"或"zh_CN"
* 对应：通用

### logo
* 说明：[可选]播放器角落logo
* 类型：字符串
* 取值：如，http://sewise.com/logo.png
* 对应：通用

### volume
* 说明：[可选]播放器默认音量值
* 类型：字符串
* 取值：0 - 1
* 对应：通用

### poster
* 说明：[可选]视频播放前显示的图像
* 类型：字符串
* 取值：如，http://www.sewise.com/img/01.png
* 对应：通用

### claritybutton
* 说明：[可选]是否显示多码率按钮
* 类型：字符串
* 取值："enable"、"disable"，缺省默认值为："enable"
* 对应：通用

### timedisplay
* 说明：[可选]是否显示播放控制栏上的时间
* 类型：字符串
* 取值："enable"、"disable"，缺省默认值为："enable"
* 对应：通用

### controlbardisplay
* 说明：[可选]是否显示播放控制栏
* 类型：字符串
* 取值："enable"、"disable"，缺省默认值为："enable"
* 对应：通用

### topbardisplay
* 说明：[可选]是否显示顶部标题
* 类型：字符串
* 取值："enable"、"disable"，缺省默认值为："enable"
* 对应：通用

### customdatas
* 说明：[可选]自定义参数对象，皮肤开发者专用定义参数
* 类型：JSON对象
* 取值：如，`customdatas: {
			"logoLink": "http://www.baidu.com/"
		 }`
* 对应：通用

### primary
* 说明：[可选]播放器启用的优先模块，当视频、流同时支持HTML5或Flash播放时，该参数用于确定优先HTML5还是Flash播放。
* 类型：字符串
* 取值：如，"html5", "flash"，缺省默认值为："html5"
* 对应：通用

### 2、非通用参数：
### a.点播专用参数
### videourl
* 说明：点播视频时的播放地址
* 类型：字符串
* 取值：如，'http://192.168.1.219:5080/flvseek/data/201310/25102442M.flv'
* 对应：flv、mp4、m3u8

### videosjsonurl
* 说明：点播视频时的JSON集播放地址
* 类型：字符串或JSON对象
* 取值：如，
` videosjsonurl: {
    "programname":"json url ? : 测试 % 地址",
    "videos": [
    	{ "name":"普通", "url":"http://219.232.161.206:5080/flvseek/data/userdata/vismam/receive/201311/TRo4TUsO.flv" },
        { "name":"标清", "url":"http://219.232.161.202:5080/flvseek/data/userdata/vod/resource/201402/OVNNwRk1.flv" }
    ]
}`
* 对应：flv、mp4、m3u8

### fallbackurls
* 说明：点播视频播放时的兼容回退地址，当videourl地址不支持时将一一验证回退地址的可播放性
* 类型：字符串或JSON对象
* 取值：如，
` fallbackurls:{
	mp4: "http://jackzhang1204.github.io/materials/mov_bbb.mp4",
	ogg: "http://jackzhang1204.github.io/materials/mov_bbb.ogg",
	webm: "http://jackzhang1204.github.io/materials/mov_bbb.webm",
	m3u8: "http://jackzhang1204.github.io/materials/mov_bbb.m3u8"
}`
* 对应：mp4、ogg、webm、m3u8

### starttime
* 说明：[可选]视频播放的开始时间
* 类型：数值
* 取值：开始播放的时间，如：234.341，缺省默认值为：从头开始
* 对应：flv、mp4、m3u8

### b.直播专用参数
### streamurl
* 说明：http-flv模式直播流的播放地址，rtmp模式直播服务器应用连接地址 + 流名称。另，通过“_”字符在流地址后添加14位的开始时间和结束时间（如："rtmp://192.168.1.219/livestream/qq3tvegb_20130812094010_20130812094210"）,可以实现流从开始时间播放到结束时间后停止流播放。
* 类型：字符串
* 取值：如，'"http://192.168.1.219:5080/livestream/v2qrgj3a.flv'，或：'rtmp://192.168.1.219:1935/livestream/v2qrgj3a'
* 对应：http、rtmp

### duration
* 说明：[可选]直播时播放器的进度条代表的时间跨度
* 类型：数字
* 取值：时间称数，如：3600
* 对应：http、rtmp

### shifttime
* 说明：[可选]直播启动播放时的开始播放时间
* 类型：字符串
* 取值：14位绝对时间字符串，如，20130413102312
* 对应：http、rtmp


## 二、参数优先级
### 1、pid与视频播放地址（如：videourl/httpurl/rtmpurl+streamname）之间，pid播放优先。